Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.field.grid
Class IntGrid3D

    java.lang.Object
      sim.field.grid.AbstractGrid3D
          sim.field.grid.IntGrid3D

All Implemented Interfaces:
  Grid3D, java.io.Serializable

public class IntGrid3D
extends AbstractGrid3D

A wrapper for 3D arrays of ints.

This object expects that the 3D arrays are rectangular. You are encouraged to access the array directly. The object implements all of the Grid3D interface. See Grid3D for rules on how to properly implement toroidal grids.

The width and height and length (z dimension) of the object are provided to avoid having to say field[x].length, etc.

See Also:
  Serialized Form

Field Summary
`int[][][]` | `field`

Fields inherited from class sim.field.grid.AbstractGrid3D
`height, length, width`

Constructor Summary
`IntGrid3D(IntGrid3D values)`
`IntGrid3D(int width, int height, int length)`
`IntGrid3D(int width, int height, int length, int initialValue)`

Method Summary
`IntGrid3D` | `add(int withThisMuch)` Sets each value in the grid to that value added to withThisMuch Returns the modified grid.
`IntGrid3D` | `add(IntGrid3D withThis)` Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid.
`int` | `get(int x, int y, int z)` Returns the element at location (x,y)
`void` | `getNeighborsHamiltonianDistance(int x, int y, int z, int dist, boolean toroidal, IntBag result, IntBag xPos, IntBag yPos, IntBag zPos)` Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) + abs(z-Z) <= dist.
`void` | `getNeighborsMaxDistance(int x, int y, int z, int dist, boolean toroidal, IntBag result, IntBag xPos, IntBag yPos, IntBag zPos)` Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y), abs(z-Z) ) <= dist.
`IntGrid3D` | `lowerBound(int toNoLowerThanThisMuch)` Thresholds the grid so that values smaller than toNoLowerThanThisMuch are changed to toNoLowerThanThisMuch Returns the modified grid.
`int` | `max()` Returns the maximum value stored in the grid
`double` | `mean()` Returns the mean value stored in the grid
`int` | `min()` Returns the minimum value stored in the grid
`IntGrid3D` | `multiply(int byThisMuch)` Sets each value in the grid to that value multiplied byThisMuch Returns the modified grid.
`IntGrid3D` | `multiply(IntGrid3D withThis)` Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid.
`int` | `set(int x, int y, int z, int val)` Sets location (x,y) to val
`IntGrid3D` | `setTo(int thisMuch)` Sets all the locations in the grid the provided element
`IntGrid3D` | `setTo(IntGrid3D values)` Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.
`IntGrid3D` | `upperBound(int toNoMoreThanThisMuch)` Thresholds the grid so that values greater to toNoMoreThanThisMuch are changed to toNoMoreThanThisMuch.

Methods inherited from class sim.field.grid.AbstractGrid3D
`getHeight, getLength, getNeighborsHamiltonianDistance, getNeighborsMaxDistance, getWidth, stx, sty, stz, tx, ty, tz`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### field

    public int[][][] field

Constructor Detail

### IntGrid3D

    public IntGrid3D(int width,
                     int height,
                     int length)

### IntGrid3D

    public IntGrid3D(int width,
                     int height,
                     int length,
                     int initialValue)

### IntGrid3D

    public IntGrid3D(IntGrid3D values)

Method Detail

### set

    public final int set(int x,
                         int y,
                         int z,
                         int val)

  Sets location (x,y) to val

### get

    public final int get(int x,
                         int y,
                         int z)

  Returns the element at location (x,y)

### max

    public final int max()

  Returns the maximum value stored in the grid

### min

    public final int min()

  Returns the minimum value stored in the grid

### mean

    public final double mean()

  Returns the mean value stored in the grid

### setTo

    public final IntGrid3D setTo(int thisMuch)

  Sets all the locations in the grid the provided element

### setTo

    public final IntGrid3D setTo(IntGrid3D values)

  Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.

### upperBound

    public final IntGrid3D upperBound(int toNoMoreThanThisMuch)

  Thresholds the grid so that values greater to toNoMoreThanThisMuch are changed to toNoMoreThanThisMuch. Returns the modified grid.

### lowerBound

    public final IntGrid3D lowerBound(int toNoLowerThanThisMuch)

  Thresholds the grid so that values smaller than toNoLowerThanThisMuch are changed to toNoLowerThanThisMuch Returns the modified grid.

### add

    public final IntGrid3D add(int withThisMuch)

  Sets each value in the grid to that value added to withThisMuch Returns the modified grid.

### add

    public final IntGrid3D add(IntGrid3D withThis)

  Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid. Returns the modified grid.

### multiply

    public final IntGrid3D multiply(int byThisMuch)

  Sets each value in the grid to that value multiplied byThisMuch Returns the modified grid.

### multiply

    public final IntGrid3D multiply(IntGrid3D withThis)

  Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid. Returns the modified grid.

### getNeighborsMaxDistance

    public final void getNeighborsMaxDistance(int x,
                                              int y,
                                              int z,
                                              int dist,
                                              boolean toroidal,
                                              IntBag result,
                                              IntBag xPos,
                                              IntBag yPos,
                                              IntBag zPos)

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y), abs(z-Z) ) <= dist. This region forms a cube 2*dist+1 cells across, centered at (X,Y,Z). If dist==1, this is equivalent to the twenty-six neighbors surrounding (X,Y,Z), plus (X,Y) itself. Places each x, y, and z value of these locations in the provided IntBags xPos, yPos, and zPos, clearing the bags first. Then places into the result IntBag the elements at each of those locations clearning it first. Returns the result IntBag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

### getNeighborsHamiltonianDistance

    public final void getNeighborsHamiltonianDistance(int x,
                                                      int y,
                                                      int z,
                                                      int dist,
                                                      boolean toroidal,
                                                      IntBag result,
                                                      IntBag xPos,
                                                      IntBag yPos,
                                                      IntBag zPos)

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) + abs(z-Z) <= dist. This region forms an octohedron 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y,Y). If dist==1 this is equivalent to the six neighbors above, below, left, and right, front, and behind (X,Y,Z)), plus (X,Y,Z) itself. Places each x, y, and z value of these locations in the provided IntBags xPos, yPos, and zPos, clearing the bags first. Then places into the result IntBag the elements at each of those locations clearning it first. Returns the result IntBag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD